// scriptonDlg.h : header file
//

#if !defined(AFX_SCRIPTONDLG_H__89A94E16_7716_4768_B47C_7F4BA60625DA__INCLUDED_)
#define AFX_SCRIPTONDLG_H__89A94E16_7716_4768_B47C_7F4BA60625DA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// CScriptonDlg dialog

class CScriptonDlg : public CDialog
{
// Construction
public:
	void Cmd_Fileout(CString cmd);
	void Cmd_Filein(CString cmd);
	BOOL m_infile_open;
	BOOL m_outfile_open;
	ifstream m_infile;
	ofstream m_outfile;

	void Cmd_ProcessEndwhile();
	void Cmd_ProcessWhile();
	void Cmd_Download(CString url,CString localfile);
	void Dll_RemoveAll();
	BOOL Dll_Call(CString Id,CString func);
	BOOL Dll_Remove(CString Id);
	BOOL Dll_Add(CString fname,CString Id);
	void Cmd_DllFunction(CString cmd);
	dlllink *m_Dlllink;

	void Httpd_Return(int type);
	BOOL Httpd_Start();
	void Cmd_StartWeb(CString cmd);
	void Httpd_Stop();
	CString m_Httpd_Choicestr[6];
	CString m_Httpd_Choice_Msg;
	CString m_Httpd_Message;
	int m_Httpd_Choice_Sel,m_Httpd_Choice_Num;
	CString m_Httpd_Input,m_Httpd_Input_Msg;
	int m_HttpdMode;
	BOOL m_Httpd,m_HttpdBreak,m_HttpdResult;
	CWinThread* pThread;
	
	void Cmd_DrawImage(CString cmd);
	void FlushMessage();
	BOOL Cmd_EvaluateIf();
	void Cmd_ProcessEndif();
	void BeginScript();
	void BreakWait();
	void CodeError();
	void UpdateView();
	void Draw_Clear(BOOL clearimage=TRUE,BOOL cleartext=TRUE,BOOL update=FALSE);

	BOOL Check_Paramnum(int num);
	BOOL GetformatCodeReplacevar(CString *pstr);
	void GetformatCodeSub(CString *pstr);
	void GetformatCode();
	BOOL GetformatNextCode();
	codestruct codes;		//R[h֘Aϐ	defines.hQ
	BOOL m_Runcode;			//sstO
	BOOL m_RunBreak;

	void RunCode(BOOL once=FALSE);
	CFile m_codefile;		//R[ht@Cւ̃nh
	BOOL m_codefileopen;	//t@CJĂ
	void CloseCodefile();
	BOOL OpenCodefile(CString filename="");

	//baseDCɂ͔wỉ摜ۊǂbufferDCɔwiƃeLXg̍ꂽ摜
	//쐬A`obt@[ƂĎgp܂
	BOOL m_BufferEnabled;
	HDC bufferDC,baseDC,imageDC,textDC,formatDC;
	HBITMAP bufferBmp,baseBmp,oldbufBmp,oldbaseBmp,
			imageBmp,oldimageBmp,textBmp,oldtextBmp,formatBmp,oldformatBmp;
	LPBYTE bufferByte,baseByte,imageByte,textByte,formatByte;

	BOOL Cleanup(BOOL ask=TRUE);
	CString m_codefname;	//R[ht@C
	CString m_varfname;		//ϐt@C
	POINT winsize;			//wỉ摜TCYA܂̓EBhETCY
	int m_choicedown;		//{^Ɖ㎞ꂩr
	BOOL m_dragwindow;		//EBhE}EXhbOړ
	POINT m_dragpoint;		//ړn߂̃}EXʒu
	POINT m_winpoint;		//ړJñEBhEʒu
	BOOL m_keydown;			//㗼̃Cxgŏׂ̃tO
	RECT m_rcBegin;			//R[hbeginʒu烊ZbgsGA
	RECT m_rcExit;			//vOI{^̃GA
	BOOL m_btBegin,m_btExit;//{^tO

	void Cmd_SendClose(CString wintitle);
	void Cmd_ProcessIf();
	void Cmd_DrawChoice();
	void Cmd_SendKeycode(CString wintitle,int code);
	void Cmd_SendKey(CString wintitle,char *string);
	void Cmd_Runshell(CString command,CString parameter="",CString path="");
	BOOL Cmd_RegisterRunonce(CString parameter="");
	int Cmd_Calculate(char *frm);
	double Cmd_Calculatef(char *frm);
	void Cmd_DrawText();
	BOOL Cmd_Gotolabel(CString label,int pos=0,BOOL stoponerror=TRUE,BOOL resetif=TRUE,BOOL resetsub=TRUE);
	void Cmd_SetWindowTitle(CString title="");
	void Cmd_SetWindowPos(CString newpos="");
	void Cmd_MessageBox(CString text);
	void Cmd_SetDefaultVar(CString varname,CString newstring);
	void Cmd_SetVar(CString varname,CString newstring);
	CString Cmd_GetVar(CString varname,CString defstring="");
	void Cmd_SetBackGround(CString filename="");
	CString Cmd_GetDefaultVar(CString varname,CString defstring="");

	void Init_GetConstantVars();

	constvars m_csvar;		//VXeŒϐ

	CScriptonDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CScriptonDlg)
	enum { IDD = IDD_SCRIPTON_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScriptonDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CScriptonDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////Httpd Functions/////
typedef struct pHandler
{
	CScriptonDlg *pDlg;
} pHandler;

typedef struct {
    char name[100];
    char val[50000];
} entry;

UINT HttpdThread (LPVOID pParam);
void HttpdServeWeb (char *text,SOCKET ConnSock,pHandler* pHnd);
void HttpdServeMsg (char *text,SOCKET ConnSock,pHandler* pHnd);
void HttpdServeInput (char *text,SOCKET ConnSock,pHandler* pHnd);
void HttpdServeChoice (char *text,SOCKET ConnSock,pHandler* pHnd);
LPSTR DecodeError(int ErrorCode);

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCRIPTONDLG_H__89A94E16_7716_4768_B47C_7F4BA60625DA__INCLUDED_)
